#! /bin/sh

# local options:  ac_help is the help message that describes them
# and LOCAL_AC_OPTIONS is the script that interprets them.  LOCAL_AC_OPTIONS
# is a script that's processed with eval, so you need to be very careful to
# make certain that what you quote is what you want to quote.

ac_help='--datadir=PATH		where all the data directories go (libdir/console)
--keymap=DIR		keymaps directory (keymaps)
--font=DIR		fonts directory (fonts)
--xlate=DIR		translation tables (xlate)
--video=DIR		videomode directory (modes)'

LOCAL_AC_OPTIONS='
case X"$1" in
X--datadir=*)DATADIR=`echo "$1" | sed -e 's/^[^=]*=//'`
	    shift 1
	    ;;
X--datadir) DATADIR="$2"
	    shift 2
	    ;;
X--keymap=*)KEYMAPDIR=`echo "$1" | sed -e 's/^[^=]*=//'`
	    shift 1
	    ;;
X--keymap)  KEYMAPDIR="$2"
	    shift 2
	    ;;
X--font=*)  FONTDIR=`echo "$1" | sed -e 's/^[^=]*=//'`
	    shift 1
	    ;;
X--font)    FONTDIR="$2"
	    shift 2
	    ;;
X--xlate=*) TRANSDIR=`echo "$1" | sed -e 's/^[^=]*=//'`
	    shift 1
	    ;;
X--xlate)   TRANSDIR="$2"
	    shift 2
	    ;;
X--video=*) VIDEOMODEDIR=`echo "$1" | sed -e 's/^[^=]*=//'`
	    shift 1
	    ;;
X--video)   VIDEOMODEDIR="$2"
	    shift 2
	    ;;
*)	    ac_error=1
	    ;;
esac'

# load in the configuration file
#
TARGET=kbd
. ./configure.inc

# and away we go
#
AC_INIT kbd

test "$DATADIR"   || DATADIR=$AC_LIB/console

AC_PROG_CC

cf_hsub() {
    AC_H $1 $2
    AC_SUB $1 $2
}

AC_SUB  BINDIR    $AC_EXEC
AC_SUB  MANDIR    $AC_MAN
cf_hsub DATADIR   ${DATADIR:-$AC_LIB/console}
cf_hsub VIDEOMODEDIR  ${VIDEOMODEDIR:-modes}
cf_hsub FONTDIR   ${FONTDIR:-fonts}
cf_hsub TRANSDIR  ${TRANSDIR:-xlate}
cf_hsub KEYMAPDIR ${KEYMAPDIR:-keymap}

# AC_PROG_LN_S
AC_PROG_YACC


# if AC_CHECK_HEADERS basis/options.h; then
#     if LIBS="-lbasis" AC_CHECK_FUNCS x_getopt; then
# 	AC_LIBS="$AC_LIBS -lbasis"
# 	AC_SUB XGETOPT
# 	HAVE_XGETOPT=T
#     fi
# fi
# test "$HAVE_XGETOPT" || AC_SUB XGETOPT options.o


# AC_CHECK_FUNCS basename

# MF_PATH_INCLUDE RANLIB ranlib true || AC_CONFIG RANLIB ':'
# MF_PATH_INCLUDE M4 m4 || AC_FAIL "kbd requires m4"

# AC_CHECK_HEADERS memory.h
# AC_CHECK_HEADERS paths.h
# AC_CHECK_HEADERS stdlib.h
# AC_CHECK_HEADERS unistd.h
# AC_HEADER_SYS_WAIT

# AC_C_CONST
# AC_TYPE_PID_T
# AC_CHECK_FUNCS dup2
# AC_CHECK_FUNCS tmpnam
# AC_CHECK_FUNCS waitpid
# AC_CHECK_FUNCS wait4
# AC_CHECK_FUNCS unsetenv
# AC_CHECK_FUNCS setenv
# AC_CHECK_FUNCS setlinebuf

AC_OUTPUT Makefile src/Makefile man1/dumpkeys.1 man1/loadkeys.1 man8/loadunimap.8 man8/setfont.8

