/*
 *   Copyright (c) 1998 David Parsons. All rights reserved.
 *   
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in
 *     the documentation and/or other materials provided with the
 *     distribution.
 *  3. All advertising materials mentioning features or use of this
 *     software must display the following acknowledgement:
 *     
 *   This product includes software developed by David Parsons
 *   (orc@pell.chi.il.us)
 *
 *  4. My name may not be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *     
 *  THIS SOFTWARE IS PROVIDED BY DAVID PARSONS ``AS IS'' AND ANY
 *  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL DAVID
 *  PARSONS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *  THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _PASSWD_D
#define _PASSWD_D

#include <pwd.h>
#include <sys/types.h>

class Passwd {
private:
    typedef enum {OK, CHANGED, NEW, DELETED} pw_status;
    struct pw_pwinfo {
	struct passwd pwd;
	int checksum;
	pw_status status;
    } *pwinfo;
    int nrpw;

    static int chk(char *blk, int len);
    static int checksum(struct pw_pwinfo &entry);
    static int pwcmp(struct pw_pwinfo *a, struct pw_pwinfo *b);

public:
    Passwd();
    ~Passwd();

    struct passwd *operator [] (char *index);	/* get user info by name */
    struct passwd *operator [] (int index);	/* get user info by uid */
    struct passwd *find (char *index);		/* procedurally */
    struct passwd *find (int index);		/*  "  "    */
    //struct passwd *newpw(char *user);		/* add a user account */
    //void deletepw (char *user);		/* delete a user account */

    //int commit();				/* commit changes */
} ;

#endif/*_PASSWD_D*/
