#include "curses.h"
#include "rogue.h"
/*
 * Now all the global variables
 */
struct trap traps[MAXTRAPS];
struct room rooms[MAXROOMS];		/* One for each room -- A level */
struct room *oldrp;			/* Roomin(&player.t_oldpos) */
struct thing player;			/* The rogue */
struct thing *beast;			/* The last beast that attacked us */
struct object *cur_armor;		/* What a well dresssed rogue wears */
struct object *cur_ring[8];		/* Which rings are being worn */
struct linked_list *lvl_obj = NULL; 
struct linked_list *mlist = NULL;
struct object *cur_weapon = NULL;
struct real_pass rpass;			/* For protection's sake! */
int def_array[MAXPDEF][MAXPATT];	/* Pre-def'd chars */
int char_type = -1;			/* what type of character is player */
int foodlev = 1;			/* how fast he eats food */
int ntraps;				/* Number of traps on this level */
int trader = 0;				/* no. of purchases */
int curprice = -1;			/* current price of item */
int no_move;				/* Number of turns held in place */

int seed;				/* Random number seed */
int dnum;				/* Dungeon number */
int max_level;				/* Deepest player has gone */
int lost_dext;				/* amount of lost dexterity */
int mpos = 0;
int no_command = 0;
int level = 1;
int purse = 0;
int inpack = 0;
int total = 0;
int no_food = 0;
int count = 0;
int food_left = HUNGERTIME;
int group = 1;
int hungry_state = F_OK;
int infest_dam=0;
int lost_str=0;
int lastscore = -1;
int hold_count = 0;
int trap_tries = 0;
int pray_time = 0;
int spell_power = 0;
int auth_or[MAXAUTH];
char curpurch[15];			/* name of item ready to buy */
char PLAYER = VPLAYER;			/* what the player looks like */
char take;				/* Thing the rogue is taking */
char prbuf[LINELEN];			/* Buffer for sprintfs */
char outbuf[BUFSIZ];			/* Output buffer for stdout */
char runch;				/* Direction player is running */
char *s_names[MAXSCROLLS];		/* Names of the scrolls */
char *p_colors[MAXPOTIONS];		/* Colors of the potions */
char *r_stones[MAXRINGS];		/* Stone settings of the rings */
char *ws_made[MAXSTICKS];		/* What sticks are made of */
char whoami[LINELEN];			/* Name of player */
char fruit[LINELEN];			/* Favorite fruit */
char huh[LINELEN];			/* The last message printed */
char *s_guess[MAXSCROLLS];		/* Players guess at what scroll is */
char *p_guess[MAXPOTIONS];		/* Players guess at what potion is */
char *r_guess[MAXRINGS];		/* Players guess at what ring is */
char *ws_guess[MAXSTICKS];		/* Players guess at what wand is */
char *ws_type[MAXSTICKS];		/* Is it a wand or a staff */
char file_name[LINELEN];		/* Save file name */
char score_file[LINELEN];		/* Score file name */
char home[LINELEN];			/* User's home directory */
WINDOW *cw;				/* Window that the player sees */
WINDOW *hw;				/* Used for the help command */
WINDOW *mw;				/* Used to store mosnters */
bool pool_teleport = FALSE;		/* just teleported from a pool */
bool inwhgt = FALSE;			/* true if from wghtchk() */
bool after;				/* True if we want after daemons */
bool waswizard;				/* Was a wizard sometime */
bool canwizard;				/* Will be permitted to do this */
bool s_know[MAXSCROLLS];		/* Does he know what a scroll does */
bool p_know[MAXPOTIONS];		/* Does he know what a potion does */
bool r_know[MAXRINGS];			/* Does he know what a ring does */
bool ws_know[MAXSTICKS];		/* Does he know what a stick does */
bool playing = TRUE; 
bool running = FALSE; 
bool fighting = FALSE; 
bool wizard = FALSE;

bool notify = TRUE; 
bool fight_flush = FALSE; 
bool terse = FALSE; 
bool door_stop = FALSE;
bool jump = FALSE; 
bool slow_invent = FALSE; 
bool firstmove = FALSE; 
bool askme = FALSE;
bool amulet = FALSE; 
bool in_shell = FALSE; 
bool monst_dead = FALSE;
coord delta;				/* Change indicated to get_dir() */
LEVTYPE levtype;			/* type of level i'm on */

char *spacemsg =	"--Press space to continue--";
char *morestr  =	"--More--";
char *retstr   =	"[Press space bar to continue]";

/*
 * weapons and their attributes
 */
struct init_weps weaps[MAXWEAPONS] = {
    { "mace",		"2d4",  "1d3", NONE,		ISMETAL, 100, 8 },
    { "long sword",	"1d12", "1d2", NONE,		ISMETAL, 60, 15 },
    { "short bow",	"1d1",  "1d1", NONE,		0, 40, 75 },
    { "arrow",		"1d1",  "1d6", BOW,		ISMANY|ISMISL, 5, 1 },
    { "dagger",		"1d6",  "1d4", NONE,		ISMETAL|ISMISL, 10, 2 },
    { "rock",		"1d2",  "1d4", SLING,		ISMANY|ISMISL, 5, 1 },
    { "two-handed sword","3d6",  "1d2", NONE,		ISMETAL, 250, 30 },
    { "sling",		"0d0",  "0d0", NONE,  		0, 5, 1 },
    { "dart",		"1d1",  "1d3", NONE,  		ISMANY|ISMISL, 5, 1 },
    { "crossbow",	"1d1",  "1d1", NONE,  		0, 100, 15 },
    { "crossbow bolt",	"1d2", "1d12", CROSSBOW,	ISMANY|ISMISL, 7, 1 },
    { "spear",		"1d6",  "1d8", NONE,		ISMETAL|ISMISL, 50, 2 },
    { "trident",	"3d4",  "1d4", NONE,		ISMETAL, 50, 25 },
    { "spetum",		"2d6",  "1d3", NONE,		ISMETAL, 50, 12 },
    { "bardiche",	"3d4",  "1d2", NONE,		ISMETAL, 125, 6 },
    { "pike",		"1d12", "1d8", NONE,		ISMETAL, 80, 18 },
    { "bastard sword",	"2d8",  "1d2", NONE,		ISMETAL, 100, 20 },
    { "halberd",	"2d6",  "1d3", NONE,		ISMETAL, 175, 10 },
    { "battle axe", 	"1d8",	"1d3", NONE,		ISMETAL, 80, 10 },
};

struct init_armor armors[MAXARMORS] = {
	{ "leather armor",		11,  8,  70, 100 },
	{ "ring mail",			22,  7,  50, 250 },
	{ "studded leather armor",	33,  7,  50, 200 },
	{ "scale mail",			45,  6,  70, 250 },
	{ "padded armor",		57,  6, 150, 150 },
	{ "chain mail",			69,  5, 100, 300 },
	{ "splint mail",		80,  4, 150, 350 },
	{ "banded mail",		90,  4, 150, 350 },
	{ "plate mail",		 	96,  3, 400, 400 },
	{ "plate armor",		100, 2, 650, 450 },
};

struct magic_item things[NUMTHINGS] = {
    { "potion",			265,	5 },	/* potion */
    { "scroll",			265,   30 },	/* scroll */
    { "food",			190,	7 },	/* food */
    { "weapon",			 50,	0 },	/* weapon */
    { "armor",			 90,	0 },	/* armor */
    { "ring",			 70,	5 },	/* ring */
    { "stick",			 70,	0 },	/* stick */
    { "amulet",			  0, -250 },	/* amulet */
};

struct magic_item s_magic[MAXSCROLLS] = {
    { "monster confusion",	 60, 125, 0, 0 },
    { "magic mapping",		 50, 150, 0, 0 },
    { "light",			 80, 100, 21, 15 },
    { "hold monster",		 30, 200, 33, 20 },
    { "sleep",			 30,  50, 20, 0 },
    { "enchantment",		180, 130, 9, 9 },
    { "identify",		200, 100, 0, 15 },
    { "scare monster",		 40, 190, 27, 21 },
    { "gold detection",		 20, 110, 0, 0 },
    { "teleportation",		 60, 165, 10, 20 },
    { "create monster",		 30,  75, 0, 0 },
    { "remove curse",		 70, 120, 9, 15 },
    { "petrification",		 10, 185, 0, 0 },
    { "genocide",		 10, 200, 0, 0 },
    { "cure disease",		 80, 160, 0, 0 },
    { "acquirement",		 10, 300, 0, 0 },
    { "protection",		 40, 150, 0, 0 },
};

struct magic_item p_magic[MAXPOTIONS] = {
    { "clear thought",		 80, 180, 27, 15 },
    { "gain ability",		180, 150, 15, 15 },
    { "see invisible",		 60, 170, 25, 15 },
    { "healing",		180, 130, 27, 27 },
    { "monster detection",	 60, 120, 0, 0 },
    { "magic detection",	 60, 105, 0, 0 },
    { "raise level",		 30, 280, 11, 10 },
    { "haste self",		120, 200, 30, 5 },
    { "restore abilities",	160, 140, 0, 0 },
    { "phasing",		 40, 240, 21, 20 },
    { "invisibility",		 30, 200, 0, 15 },
};

struct magic_item r_magic[MAXRINGS] = {

    { "protection",		 80, 200, 33, 25 },
    { "add strength",		 70, 200, 33, 25 },
    { "sustain ability",	 50, 180, 0, 0 },
    { "searching",		 70, 200, 0, 0 },
    { "extra sight",		 40, 175, 0, 0 },
    { "alertness",		 40, 190, 0, 0 },
    { "aggravate monster",	 50, 100, 100, 0 },
    { "dexterity",		 70, 220, 33, 25 },
    { "increase damage",	 80, 220, 33, 25 },
    { "regeneration",		 40, 260, 0, 0 },
    { "slow digestion",		 40, 240, 15, 10 },
    { "teleportation",		 40, 100, 100, 0 },
    { "stealth",		 50, 100, 0, 0 },
    { "add intelligence",	 70, 240, 33, 25 },
    { "increase wisdom",	 70, 220, 33, 25 },
    { "sustain health",		 80, 250, 0,  0 },
    { "burden",			 20, 100, 100, 0 },
    { "illumination",		 20, 200, 0, 0 },
    { "delusion",		 20, 100, 75, 0 },
};

struct magic_item ws_magic[MAXSTICKS] = {
    { "light",			100, 120, 20, 20 },
    { "striking",		 60, 115, 0, 0 },
    { "lightning",		 30, 200, 0, 0 },
    { "fire",			 30, 200, 0, 0 },
    { "cold",			 30, 200, 0, 0 },
    { "polymorph",		100, 210, 0, 0 },
    { "magic missile",		100, 170, 0, 0 },
    { "slow monster",		 80, 220, 25, 20 },
    { "drain life",		 90, 210, 20, 0 },
    { "charging",		 80, 100, 0, 0 },
    { "teleport monster",	 90, 140, 25, 20 },
    { "cancellation",		 40, 130, 0, 0 },
    { "confuse monster",   	 50, 100, 0, 0},
    { "disintegration",	  	 15, 150, 33, 0},
    { "anti-matter",		 30, 180, 0, 0},
    { "paralyze monster",	 45, 180, 0, 0},
    { "degenerate monster",	 30, 200, 30, 0},

};

/*
 * these are the spells that a magic user can cast
 */
struct spells magic_spells[MAXSPELLS] = {
	{ P_TFIND,		3,	TYP_POTION,	FALSE },
	{ S_IDENT,		5,	TYP_SCROLL,	FALSE },
	{ P_MFIND,		7,	TYP_POTION,	FALSE },
	{ S_LIGHT,		15,	TYP_SCROLL,	TRUE  },
	{ S_REMOVE,		15,	TYP_SCROLL,	FALSE },
	{ S_TELEP,		15,	TYP_SCROLL,	FALSE },
	{ S_CONFUSE,		15,	TYP_SCROLL,	FALSE },
	{ S_MAP,		15,	TYP_SCROLL,	FALSE },
	{ P_CLEAR,		20,	TYP_POTION,	FALSE },
	{ S_SLEEP,		25,	TYP_SCROLL,	FALSE },
	{ WS_MISSILE,		25,	TYP_STICK,	FALSE },
	{ P_SEEINVIS,		25,	TYP_POTION,	TRUE  },
	{ WS_COLD,		30,	TYP_STICK,	FALSE },
	{ WS_ELECT,		30,	TYP_STICK,	FALSE },
	{ WS_CANCEL,		30,	TYP_STICK,	FALSE },
	{ S_PROTECT,		30,	TYP_SCROLL,	FALSE },
	{ WS_FIRE,		30,	TYP_STICK,	FALSE },
	{ P_PHASE,		40,	TYP_POTION,	FALSE },
	{ S_HOLD,		50,	TYP_SCROLL,	FALSE },
	{ S_PETRIFY,		50,	TYP_SCROLL,	FALSE },
	{ S_ALLENCH,		75,	TYP_SCROLL,	FALSE },
};

/*
 * these are the spells that a cleric can cast
 */
struct spells cleric_spells[MAXPRAYERS] = {
	{ P_MFIND,		3,	TYP_POTION,	FALSE },

	{ P_TFIND,		7,	TYP_POTION,	FALSE },
	{ S_IDENT,		15,	TYP_SCROLL,	FALSE },
	{ S_REMOVE,		20,	TYP_SCROLL,	FALSE },
	{ P_HEALING,		30,	TYP_POTION,	FALSE },
	{ S_CURING,		35,	TYP_SCROLL,	FALSE },
	{ P_HASTE,		35,	TYP_POTION,	FALSE },
	{ P_CLEAR,		35,	TYP_POTION,	FALSE },
	{ P_SEEINVIS,		35,	TYP_POTION,	TRUE  },
	{ P_RESTORE,		35,	TYP_POTION,	FALSE },
	{ P_PHASE,		40,	TYP_POTION,	FALSE },
	{ S_TELEP,		40,	TYP_SCROLL,	FALSE },
};

char *cnames[4][11] = {
{	"Veteran",		"Warrior",	
	"Swordsman",		"Hero",
	"Swashbuckler",		"Myrmidon",	
	"Champion",		"Superhero",
	"Lord",			"Lord",		
	"Lord"
},
{	"Prestidigitator",	"Evoker",	
	"Conjurer",		"Theurgist",
	"Thaumaturgist",	"Magician",	
	"Enchanter",		"Warlock",
	"Sorcerer",		"Necromancer",
	"Wizard"
},
{	"Acolyte",		"Adept",
	"Priest",		"Curate",
	"Prefect",		"Canon",
	"Lama",			"Patriarch",
	"High Priest",		"High Priest",
	"High Priest"
},
{	"Rogue",		"Footpad",
	"Cutpurse",		"Robber",
	"Burglar",		"Filcher",
	"Sharper",		"Magsman",
	"Thief",		"Master Thief",

	"Master Thief"
}
} ;

struct h_list helpstr[] = {
    '?',	"	prints help",
    '/',	"	identify object",
    'h',	"	left",
    'j',	"	down",
    'k',	"	up",
    'l',	"	right",
    'y',	"	up & left",
    'u',	"	up & right",
    'b',	"	down & left",
    'n',	"	down & right",
    '<',	"CTRL><dir> run til adjacent",
    '<',	"SHIFT><dir> run that way",
    'm',	"<dir>	move onto without picking up",
    't',	"<dir>	throw something",
    'z',	"<dir>	zap a wand or staff",
    '>',	"	go down a staircase",
    's',	"	search for trap/secret door",
    '.',	"	rest for a while",
    'i',	"	inventory",
    'I',	"	inventory single item",
    'q',	"	quaff potion",
    'r',	"	read paper",
    'e',	"	eat food",
    'w',	"	wield a weapon",
    'W',	"	wear armor",
    'T',	"	take armor off",
    'P',	"	put on ring",
    'R',	"	remove ring",

    'd',	"	drop object",
    'c',	"	call object (generic)",
    'M',	"	mark object (specific)",
    'o',	"	examine/set options",
    'C',	"	cast a spell",

    'p',	"	pray",
    'a',	"	affect the undead",
    '^',	"	set a trap",
    'G',	"	sense gold",
    'D',	"	dip something (into a pool)",
    CTRL(T),	"<dir>	take (steal) from (direction)",
    CTRL(R),	"	redraw screen",
    CTRL(P),	"	repeat last message",
    ESCAPE,	"	cancel command",
    'v',	"	print program version number",
    '!',	"	shell escape",
    'S',	"	save game",
    'Q',	"	quit",
/*
 * Wizard commands.  Identified by (h_ch != 0 && h_desc == 0).
 */
	'-',		0,
	CTRL(A),	"	system statistics",
	CTRL(C),	"	charge item",
	CTRL(D),	"	down one level",
	CTRL(E),	"	food statistics",
	CTRL(F),	"	floor map",
	CTRL(G),	"	goto level",
	CTRL(I),	"	inventory level",
	CTRL(M),	"	see monster",
	CTRL(O),	"	outfit pack",
	CTRL(Q),	"	random number check",

	CTRL(S),	"	ascend one level",
	CTRL(V),	"	create item",
	CTRL(W),	"	wizard's password",
	CTRL(X),	"	random teleport",
	CTRL(Z),	"	identify item",
	0,		0
};

#define HPT(x) x
struct monster monsters[NUMMONST+1] = {
/* "Name",
		CARRY,	NORMAL,	WANDER,	APPEAR,	INTEL,
		{ATTRIBUTES},
		ADDED_EXPERIENCE/HIT_POINT,
		{str	exp,	level,	"armor", hit_points,
		"damage"}}, */
{"unknown",
		0,	FALSE,	FALSE,	'\0',	"",
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		0,
		0, 0,
		{10,	0,	0,	0,	HPT(""),
		""}},
{"bat",
		0,	TRUE,	FALSE,	'b',	"2-4",
		{ISMEAN, ISHUH, CANDISEASE},
		0, 0,
		0,
		{10,	5,	2,	1,	HPT("1d4"),
		"1d2"}},
{"giant rat",
		0,	TRUE,	TRUE,	'R',	"2-4",
		{ISMEAN, CANDISEASE},
		0, 0,
		1,
		{10,	7,	1,	7,	HPT("1d4"),
		"1d3"}},
{"kobold",
		0,	TRUE,	TRUE,	'K',	"8-8",
		{ISMEAN, CANSHOOT},
		0, 0,
		1,
		{9,	5,	1,	7,	HPT("1d4"),
		"1d4"}},
{"gnome",
		10,	TRUE,	TRUE,	'G',	"11-12",
		{CANSHOOT},
		0, 0,
		1,
		{10,	8,	1,	5,	HPT("1d6"),
		"1d6"}},
{"halfling",

		10,	TRUE,	TRUE,	'H',	"11-12",
		{CANSHOOT},
		0, 0,
		1,
		{8,	9,	1,	4,	HPT("1d6"),
		"1d6"}},
{"dwarf",
		15,	TRUE,	TRUE,	'D',	"11-12",
		{CANSHOOT},
		0, 0,
		1,
		{14,	10,	1,	4,	HPT("1d8"),

		"1d8"}},
{"orc",
		15,	TRUE,	TRUE,	'O',	"8-8",
		{ISMEAN, CANSHOOT},
		0, 0,
		1,
		{12,	10,	1,	6,	HPT("1d8"),
		"1d8"}},
{"manes",
		0,	TRUE,	TRUE,	'M',	"2-4",
		{ISMEAN, MAGICHIT, ISUNDEAD},
		0, 0,
		1,
		{10,	18,	1,	7,	HPT("1d8"),
		"1d2/1d2/1d4"}},
{"elf",
		50,	TRUE,	TRUE,	'E',	"13-20",
		{CANSHOOT},
		0, 0,
		2,
		{12,	20,	1,	5,	HPT("1d8+1"),
		"1d10"}},
{"hobgoblin",
		0,	TRUE,	TRUE,	'h',	"8-10",
		{ISMEAN, CANSHOOT},
		0, 0,
		2,
		{14,	20,	1,	5,	HPT("1d8+1"),
		"1d8"}},
{"fire beetle", 
		0,	TRUE,	TRUE,	'B',	"0-0",
		{ISMEAN, HASFIRE},
		0, 0,
		2,
		{10,	20,	1,	4,	HPT("1d8+2"),
		"2d4"}},
{"giant ant",
		0,	TRUE,	TRUE,	'A',	"1-1",
		{ISMEAN, CANPOISON},
		0, 0,
		3,
		{10,	40,	2,	3,	HPT("2d8"),
		"2d4/3d4"}},
{"zombie",
		0,	TRUE,	TRUE,	'Z',	"0-0",
		{ISMEAN, ISUNDEAD},
		0, 0,

		2,
		{10,	20,	2,	8,	HPT("2d8"),
		"1d8"}},
{"ear seeker",
		0,	TRUE,	TRUE,	'e',	"0-0",
		{ISMEAN, CANINFEST},
		0, 0,
		0,
		{10,	0,	1,	9,	HPT("1d1"),
		"0d0"}},
{"shrieker",
		0,	TRUE,	FALSE,	'S',	"0-0",
		{CANSHRIEK, NOMOVE},
		0, 0,
		1,
		{10,	5,	3,	7,	HPT("3d8"),
		"0d0"}},
{"stirge",
		0,	TRUE,	TRUE,	's',	"1-1",
		{ISMEAN, CANDRAW},
		0, 0,
		2,
		{10,	36,	4,	8,	HPT("1d8+1"),
		"1d3"}},
{"troglodyte",
		5,	TRUE,	TRUE,	'T',	"5-7",
		{ISMEAN, CANSMELL, CANSHOOT},
		0, 0,
		2,
		{10,	36,	2,	5,	HPT("2d8"),
		"1d3/1d3/2d5"}},

{"lemure",
		0,	TRUE,	FALSE,	'L',	"2-4",
		{ISMEAN, ISREGEN, MAGICHIT, ISUNDEAD},
		0, 0,
		3,
		{10,	65,	3,	7,	HPT("3d8"),
		"1d3"}},
{"bugbear",
		5,	TRUE,	TRUE,	'b',	"5-8",
		{ISMEAN, CANSHOOT, CANSURPRISE},

		0, 0,
		4,
		{16,	135,	3,	5,	HPT("3d8+1"),
		"2d4"}},
{"wererat",
		20,	TRUE,	TRUE,	'r',	"11-12",
		{ISMEAN, MAGICHIT},
		0, 0,
		4,
		{10,	150,	3,	6,	HPT("3d8+1"),
		"1d8"}},
{"ghoul",
		0,	TRUE,	TRUE,	'g',	"5-7",
		{ISMEAN, CANPARALYZE, ISUNDEAD},
		0, 0,
		2,
		{10,	65,	2,	6,	HPT("2d8"),
		"1d3/1d3/1d6"}},
{"leprechaun",
		0,	TRUE,	FALSE,	'l',	"15-16",
		{ISFLEE, CARRYGOLD, STEALGOLD},
		0, 0,
		1,
		{10,	80,	6,	5,	HPT("1d4+1"),
		"0d0"}},
{"ogre",
		50,	TRUE,	TRUE,	'o',	"5-7",
		{ISMEAN},
		0, 0,
		5,
		{18,	90,	4,	5,	HPT("4d8+1"),
		"1d10"}},
{"centaur",
		15,	TRUE,	TRUE,	'C',	"5-10",
		{CANSHOOT},
		0, 0,
		4,
		{10,	85,	4,	4,	HPT("4d8"),
		"1d6/1d6"}},
{"nymph",
		100,	TRUE,	FALSE,	'N',	"15-16",
		{ISFLEE, STEALMAGIC},
		0, 0,
		3,
		{10,	350,	4,	9,	HPT("3d8"),
		"0d0"}},
{"violet fungi", 
		0,	TRUE,	FALSE,	'F',	"0-0",
		{ISMEAN, CANHOLD, NOMOVE, CANROT},
		0, 0,
		4,
		{10,	135,	3,	7,	HPT("3d8"),
		"5d1"}},
{"giant tick",
		0,	TRUE,	TRUE,	't',	"0-0",
		{ISMEAN, CANDRAW, CANDISEASE},
		0, 0,
		2,
		{10,	105,	3,	3,	HPT("3d8"),
		"1d4"}},
{"gelatinous cube", 
		90, TRUE,	TRUE,	'c',	"0-0",
		{ISMEAN, ISSCAVENGE, CANPARALYZE},
		0, 0,
		4,
		{10,	150,	4,	8,	HPT("4d8"),
		"2d4"}},
{"blink dog",
		0,	TRUE,	TRUE,	'B',	"8-10",
		{ISMEAN, CANBLINK},
		0, 0,
		5,
		{10,	170,	4,	5,	HPT("4d8"),
		"1d6"}},
{"very young dragon", 
		10, TRUE, FALSE, 'd',	"15-16",
		{ISMEAN, CANBRANDOM, ISGREED},
		0, 0,
		9,

		{10,	100,	9,	-1,	HPT("9d1"),
		"1d8/1d8/3d10"}},
{"rust monster", 
		0,	TRUE,	TRUE,	'R',	"1-1",
		{ISMEAN, CANRUST},
		0, 0,
		4,
		{10,	185,	5,	2,	HPT("3d8"),
		"0d0/0d0"}},
{"ghast",
		0,	TRUE,	TRUE,	'G',	"11-12",
		{CANPARALYZE, CANSTINK, ISMEAN, ISUNDEAD},
		0, 0,
		4,
		{10,	190,	4,	4,	HPT("4d8"),
		"1d4/1d4/1d8"}},
{"blindheim",
		0,	TRUE,	FALSE,	'b',	"1",
		{CANBLIND, ISMEAN},
		0, 0,
		4,
		{8,	200,	2,	1,	HPT("4d8+2"),
		"1d8"}},
{"shadow",
		0,	TRUE,	TRUE,	'S',	"5-7",
		{ISSHADOW, ISMEAN, CANCHILL, ISUNDEAD},
		0, 0,
		4,
		{10,	255,	3,	7,	HPT("3d8+3"),
		"1d4+1"}},
{"gargoyle",
		5,	TRUE,	TRUE,	'g',	"5-7",
		{ISMEAN, MAGICHIT},
		0, 0,
		5,
		{10,	165,	4,	5,	HPT("4d8+4"),
		"1d3/1d3/1d6/1d4"}},
{"su-monster", 10,	TRUE,	TRUE,	's',	"8-10",
		{ISMEAN},
		0, 0,
		6,
		{10,	225,	5,	6,	HPT("5d8+5"),
		"4d4/2d4"}},
{"gray ooze", 
		50,	TRUE,	FALSE,	'o',	"1-1",
		{ISMEAN, NOMOVE, CANRUST, ISSCAVENGE},
		0, 0,
		5,
		{10,	200,	3,	8,	HPT("3d8+3"),
		"2d8"}},
{"owlbear",
		5,	TRUE,	TRUE,	'O',	"5-7",
		{ISMEAN, CANHUG},
		0, 0,
		8,
		{10,	225,	5,	5,	HPT("5d8+2"),
		"1d6/1d6/2d6"}},

{"quasit",
		30,	TRUE,	TRUE,	'Q',	"5-7",
		{ISMEAN, ISREGEN, MAGICHIT, CANSURPRISE, CANITCH},
		0, 0,
		3,
		{10,	325,	7,	2,	HPT("3d8"),
		"1d2/1d2/1d4"}},
{"doppleganger", 
		0,	TRUE,	TRUE,	'D',	"11-12",
		{ISMEAN, CANSURPRISE},
		0, 0,
		4,
		{10,	330,	10,	5,	HPT("4d8"),
		"1d12"}},
{"yeti",	
		30,	TRUE,	TRUE,	'Y',	"8-10",
		{ISMEAN, CANPARALYZE, CANHUG, NOCOLD, CANSURPRISE},
		0, 0,
		8,
		{13,	500,	6,	6,	HPT("4d8+4"),
		"1d6/1d6"}},
{"leucrotta", 
		0,	TRUE,	FALSE,	'L',	"8-10",
		{ISMEAN},
		0, 0,
		8,	
		{10,	475,	6,	4,	HPT("6d8+1"),
		"3d6/1d6/1d6"}},
{"imp", 
		25,	TRUE,	TRUE,	'I',	"8-10",
		{ISMEAN, ISREGEN, MAGICHIT, CANPOISON, CANSURPRISE},
		0, 0,
		3,
		{10,	275,	2,	2,	HPT("2d8+2"),
		"1d4"}},
{"cockatrice", 
		0,	TRUE,	TRUE,	'C',	"1-1",
		{ISMEAN, TOUCHSTONE},
		0, 0,
		5,
		{10,	315,	5,	6,	HPT("5d8"),
		"1d3"}},
{"wight",
		35,	TRUE,	TRUE,	'W',	"8-10",
		{ISMEAN, CANDRAIN, MAGICHIT, ISUNDEAD},
		0, 0,
		5,
		{10,	540,	4,	5,	HPT("4d8+3"),
		"1d4"}},
{"troll",
		50,	TRUE,	FALSE,	'T',	"5-7",
		{ISMEAN, ISREGEN},
		0, 0,
		8,
		{18,	600,	6,	4,	HPT("6d8+6"),
		"1d4+4/1d4+4/2d6"}},
{"jackalwere", 
		50,	TRUE,	TRUE,	'J',	"11-12",
		{ISMEAN, CANSHOOT, CANSNORE, MAGICHIT},
		0, 0,
		4,
		{10,	800,	4,	4,	HPT("4d8"),
		"2d4"}},
{"wraith",
		0,	TRUE,	TRUE,	'w',	"11-12",
		{ISMEAN, CANDRAIN, MAGICHIT, ISUNDEAD},
		0, 0,
		6,
		{10,	575,	5,	4,	HPT("5d8+3"),
		"1d6"}},
{"basilisk",
		0,	TRUE,	TRUE,	'B',	"1-1",
		{ISMEAN, LOOKSTONE},
		0, 0,
		8,
		{10,	1000,	6,	4,	HPT("6d8+1"),
		"1d10"}},
{"erinyes",
		25,	TRUE,	TRUE,	'E',	"8-10",
		{ISMEAN, CANFRIGHTEN, CANSUMMON, ISUNDEAD},
		"ghoul", 3, 
		8,
		{10,	875,	7,	2,	HPT("6d8+6"),
		"2d4"}},
{"mummy",
		20,	TRUE,	FALSE,	'm',	"5-7",
		{ISMEAN,CANINFEST, MAGICHIT, CANFRIGHTEN, HALFDAMAGE, ISUNDEAD},
		0, 0,
		8,
		{10,	1150,	6,	3,	HPT("6d8+3"),
		"1d12"}},
{"otyugh",
		0,	TRUE,	TRUE,	'o',	"5-10",
		{ISMEAN, CANDISEASE},
		0, 0,
		8,
		{10,	700,	7,	3,	HPT("7d8"),
		"1d8/1d8/1d4+1"}},
{"adult dragon", 
		30,	TRUE,	FALSE,	'd',	"15-16",
		{ISMEAN, CANBRANDOM, ISGREED, CANFRIGHTEN},
		0, 0,
		9,
		{10,	1000,	9,	-1,	HPT("45d1"),
		"1d8/1d8/3d10"}},
{"invisible stalker", 
		0, TRUE,	TRUE,	'i',	"13-14",
		{ISMEAN, ISINVIS},
		0, 0,
		10,
		{10,	1090,	8,	3,	HPT("8d8"),
		"4d4"}},
{"xorn",
		0,	TRUE,	TRUE,	'X',	"8-10",
		{ISMEAN, CANINWALL, NOCOLD, NOFIRE, CANSURPRISE},
		0, 0,
		10,
		{10,	1275,	7,	-2,	HPT("7d8+7"),
		"1d3/1d3/1d3/4d6"}},
{"will-o-wisp", 100,	TRUE,	FALSE,	'W',	"15-16",
		{ISMEAN, CANSURPRISE},
		0, 0,
		12,
		{10,	1200,	9,	-8,	HPT("9d8"),
		"2d8"}},
{"chimera",
		0,	TRUE,	FALSE,	'c',	"2-4",
		{ISMEAN, CANBFIRE},
		0, 0,
		12,
		{10,	1000,	9,	6,	HPT("9d8"),
		"1d3/1d3/1d4/1d4/2d4/3d4"}},
{"mimic",
		30,	TRUE,	FALSE,	'M',	"2-10",
		{ISDISGUISE, CANHOLD},
		0, 0,
		12,
		{10,	1300,	9,	7,	HPT("9d8"),
		"3d4"}},
{"horned devil", 
		5,	TRUE,	TRUE,	'H',	"13-14",

		{ISMEAN, CANFRIGHTEN, CANINFEST, CANPOISON, MAGICHIT, CANSUMMON},
		"wight", 2, 
		6,
		{10,	1320,	7,	-3,	HPT("5d8+5"),
		"1d4/1d4/1d4+1/1d3"}},
{"specter",
		0,	TRUE,	TRUE,	'S',	"13-14",
		{ISMEAN, DOUBLEDRAIN, ISUNDEAD},
		0, 0,
		10,
		{10,	1650,	7,	2,	HPT("7d8+3"),
		"1d8"}},
{"neo-otyugh",
		0,	TRUE,	TRUE,	'N',	"10-12",
		{ISMEAN, CANDISEASE},
		0, 0,
		10,
		{12,	1500,	10,	0,	HPT("12d8"),
		"2d6/2d6/1d3"}},
{"barbed devil", 
		0,	TRUE,	TRUE,	'B',	"11-12",
		{TOUCHFEAR, CANSUMMON, ISMEAN, CANHOLD, ISUNDEAD},
		"ghast", 4, 
		10,
		{10,	1425,	8,	0,	HPT("8d8"),
		"2d4/2d4/3d4"}},
{"vrock",
		10,	TRUE,	TRUE,	'V',	"5-7",
		{ISMEAN, CANSUMMON, CANSEE, ISUNDEAD},
		"ghast", 4, 
		10,
		{10,	1500,	8,	0,	HPT("8d8"),
		"1d4/1d4/1d8/1d8/1d6"}},
{"shambling mound", 
		25, TRUE,	TRUE,	's',	"5-7",
		{ISMEAN, CANSUFFOCATE, NOCOLD, NOFIRE, CANHOLD},
		0, 0,
		10,
		{10,	1800,	9,	0,	HPT("9d8"),
		"2d8/2d8"}},
{"umber hulk",
		40,	TRUE,	TRUE,	'U',	"8-10",
		{ISMEAN, CANHUH},
		0, 0,
		12,
		{10,	1700,	8,	2,	HPT("8d8+8"),
		"3d4/3d4/2d5"}},
{"ettin",
		0,	TRUE,	TRUE,	'e',	"0-0",
		{ISMEAN, CANSHOOT},
		0, 0,
		14,
		{10,	1950,	10,	3,	HPT("10d8"),
		"2d8/3d6"}},
{"black pudding", 
		70,	TRUE,	FALSE,	'P',	"0-0",
		{ISMEAN, CANRUST, NOCOLD, BOLTDIVIDE, BLOWDIVIDE, ISSCAVENGE},

		0, 0,
		14,
		{10,	2000,	10,	6,	HPT("10d8"),
		"3d8"}},
{"hezrou",
		15,	TRUE,	TRUE,	'h',	"5-7",
		{ISMEAN, CANFRIGHTEN, CANSEE, CANSUMMON, ISUNDEAD},
		"wight", 3, 
		12,
		{10,	2000,	9,	-2,	HPT("9d8"),
		"1d3/1d3/4d4"}},
{"glabrezu",
		25,	TRUE,	FALSE,	'G',	"8-10",
		{ISMEAN, CANFRIGHTEN, CANSEE, CANSUMMON, ISUNDEAD},
		"wraith", 3, 
		14,
		{10,	2400,	10,	-4,	HPT("10d8"),
		"2d6/2d6/1d3/1d3/1d4+1"}},
{"bone devil",
		0,	TRUE,	TRUE,	'b',	"11-12",
		{ISMEAN, CANFRIGHTEN, CANSEE, CANSUMMON, CANSURPRISE, CANCHILL, ISUNDEAD},
		"ghast", 3, 
		12,
		{10,	2800,	9,	-1,	HPT("9d8"),
		"2d4"}},
{"vampire",
		20,	TRUE,	TRUE,	'v',	"15-16",
		{ISMEAN, ISREGEN, CANSUCK, ISUNDEAD},
		0, 0,
		12,
		{20,	3800,	8,	1,	HPT("8d8+3"),
		"1d6+4"}},
{"ice devil",
		30,	TRUE,	FALSE,	'I',	"13-14",
		{ISMEAN, CANSEE, ISREGEN, CANFRIGHTEN, CANSUMMON, CANBICE, NOCOLD},
		"bone devil", 2, 
		16,
		{20,	4400,	11,	-4,	HPT("11d8"),
		"1d4/1d4/2d4/3d4"}},

{"purple worm", 
		70,	TRUE,	FALSE,	'p',	"0-0",
		{ISMEAN},
		0, 0,

		20,
		{10,	4900,	15,	6,	HPT("15d8"),
		"2d12"}},
{"pit fiend",
		100,	TRUE,	TRUE,	'f',	"15-16",
		{ISMEAN, CANSEE, BMAGICHIT, CANFRIGHTEN, CANHOLD, CANSUMMON, CANBFIRE, NOFIRE},
		"erinyes", 2, 
		18,
		{22,	7900,	13,	-3,	HPT("13d8"),
		"1d4+4/1d6+6"}},
{"titan",
		100,	TRUE,	FALSE,	't',	"17-20",
		{ISSHADOW},
		0, 0,
		30,
		{10,	9000,	19,	0,	HPT("19d8"),
		"7d6"}},
{"lich",
		100,	TRUE,	TRUE,	'l',	"19-20",
		{ISMEAN, CANPARALYZE, CANFRIGHTEN, MAGICHIT, ISUNDEAD, NOBOLT},
		0, 0,
		16,
		{10,	10500,	11,	0,	HPT("11d8"),
		"1d10"}},
{"ancient brass dragon", 
		100, TRUE, FALSE, 'r', "13-14",
		{CANBSGAS, CANBFGAS, ISGREED},
		0, 0,
		50,
		{10,	20000,	8,	2,	HPT("0d8+64"),
		"1d4/1d4/4d4"}},
{"ancient white dragon", 
		100, TRUE, TRUE, 'W', "8-9",
		{ISMEAN, CANBICE, ISGREED},
		0, 0,
		50,
		{10,	20000,	7,	3,	HPT("0d8+56"),
		"1d4/1d4/2d8"}},
{"ancient black dragon", 
		100, TRUE, TRUE, 'a', "8-10",
		{ISMEAN, CANBACID, ISGREED},
		0, 0,
		50,
		{10,	20000,	8,	3,	HPT("0d8+64"),
		"1d4/1d4/3d6"}},
{"ancient copper dragon", 
		100, TRUE, FALSE, 'c', "13-14",
		{CANBACID, CANBSLGAS, ISGREED},
		0, 0,
		50,
		{10,	20000,	9,	1,	HPT("0d8+72"),
		"1d4/1d4/5d4"}},
{"ancient green dragon", 
		100, TRUE, TRUE, 'E', "8-12",
		{ISMEAN, CANBGAS, ISGREED},
		0, 0,
		50,
		{10,	20000,	9,	2,	HPT("0d8+72"),
		"1d6/1d6/2d10"}},
{"ancient bronze dragon", 
		100, TRUE, FALSE, 'L', "15-16",
		{CANBBOLT, CANBFGAS, ISGREED},
		0, 0,
		50,
		{10,	20000,	10,	0,	HPT("0d8+80"),
		"1d6/1d6/4d6"}},
{"ancient blue dragon", 

		100, TRUE, TRUE, 'u', "11-12",
		{ISMEAN, CANBBOLT, ISGREED},
		0, 0,
		50,
		{10,	20000,	10,	2,	HPT("0d8+80"),
		"1d6/1d6/3d8"}},
{"ancient silver dragon", 
		100, TRUE, FALSE, 'S', "15-16",
		{CANBICE, CANBPGAS, ISGREED},
		0, 0,
		50,
		{10,	20000,	11,	-1,	HPT("0d8+88"),
		"1d6/1d6/5d6"}},
{"frost giant",
		50, TRUE, TRUE, 'F', "5-10",
		{ISMEAN, CARRYGOLD, NOCOLD},
		0, 0,
		40,
		{25,	20000,	15,	4,	HPT("10d8+4"),
		"4d6"}},
{"ancient red dragon", 
		100, TRUE, TRUE, 'R', "15-16",
		{ISMEAN, CANBFIRE, ISGREED},
		0, 0,
		50,
		{10,	20000,	11,	-1,	HPT("0d8+88"),
		"1d8/1d8/3d10"}},
{"ancient gold dragon", 
		100, TRUE, FALSE, 'G', "17-18",
		{CANBFIRE, CANBGAS, ISGREED},
		0, 0,
		50,
		{10,	20000,	12,	-2,	HPT("0d8+96"),
		"1d8/1d8/6d6"}},
{"fire giant",
		50, TRUE, TRUE, 'f', "6-10",
		{ISMEAN, CARRYGOLD, NOFIRE},
		0, 0,
		45,
		{27,	26000,	15,	4,	HPT("11d8+5"),
		"5d6"}},
{"storm giant",
		50, TRUE, TRUE, 's', "8-10",

		{ISMEAN,  NOBOLT, CANBBOLT},
		0, 0,
		50,
		{30,	30000,	15,	2,	HPT("15d8+8"),
		"7d6"}},
{"demon prince (Jubilex)", 
		100, TRUE, FALSE, 'J', "17-18",
		{ISMEAN, ISUNIQUE, CANFRIGHTEN, ISREGEN, BMAGICHIT, ISSHADOW, CANHOLD, CANDISEASE, CANSUMMON},
		"black pudding", 3, 
		0,
		{10,	47280,	20,	-7,	HPT("0d8+88"),
		"4d10"}},
{"arch devil (Geryon)", 
		100, TRUE, FALSE, 'g', "15-16",
		{ISMEAN, ISUNIQUE, BMAGICHIT, CANSEE, ISSHADOW, CANFRIGHTEN, CANHUH, CANPOISON, CANSUMMON},
		"ice devil", 2, 
		0,
		{13,	47975,	30,	-3,	HPT("0d8+133"),
		"3d6/3d6/2d4"}},
{"arch devil (Dispater)", 
		100, TRUE, FALSE, 'd', "17-18",
		{ISMEAN, ISUNIQUE, CANSEE, CANFRIGHTEN, CANHUH, BMAGICHIT, CANSUMMON},
		"pit fiend", 2, 
		0,
		{10,	48040,	36,	-2,	HPT("0d8+144"),
		"4d6"}},
{"demon prince (Yeenoghu)", 
		100, TRUE, FALSE, 'Y', "15-16",
		{ISMEAN, ISREGEN, ISUNIQUE, MAGICHIT, CANSEE, ISSHADOW, CANHOLD, CANFRIGHTEN, CANPARALYZE, CANSUMMON},
		"ghoul", 10, 
		0,
		{10,	54500,	23,	-5,	HPT("0d8+100"),

		"3d6/3d6"}},
{"lesser god (Tom)",
		50, TRUE, FALSE, 'T', "17",
		{ISMEAN, CANSEE, ISUNIQUE, CANSUMMON},
		"owlbear", 5,
		0,
		{13,	55000,	25,	0,	HPT("0d8+221"),
		"2d8/2d8"}},
{"lesser god (Dave)",
		50, TRUE, TRUE, 'D', "19",
		{ISMEAN, CANFRIGHTEN, CANPOISON, CANSEE, ISUNIQUE},
		0, 0,
		0,
		{16,	55000,	27,	0,	HPT("0d8+219"),
		"2d12/1d6"}},
{"lesser god (Derek)",
		0, TRUE, TRUE, 'Z', "18",
		{ISMEAN, ISUNIQUE, ISREGEN, MAGICHIT, CANSEE, CANSUMMON},
		"troll", 5,
		0,
		{16,	56000,	26,	0,	HPT("0d8+198"),

		"2d10/2d10/1d12"}},
{"platinum dragon (Bahamut)", 
		100, TRUE, FALSE, 'P', "19-20",
		{ISUNIQUE, CANBICE, CANBGAS, CANBBOLT, ISGREED, CANSUMMON},
		"ancient gold dragon", 7,
		0,
		{10,	58080,	38,	-3,	HPT("0d8+168"),
		"2d6/2d6/6d8"}},
{"arch devil (Baalzebul)", 
		100, TRUE, FALSE, 'B', "17-18",
		{ISMEAN, ISSHADOW, ISUNIQUE, BMAGICHIT, CANHOLD, CANPOISON, CANFRIGHTEN, CANHUH, CANSUMMON},
		"horned devil", 4, 
		0,
		{10,	61410,	37,	-5,	HPT("0d8+166"),
		"2d6"}},
{"chromatic dragon (Tiamat)", 
		100, TRUE, FALSE, 'C', "17-18",
		{ISMEAN, ISUNIQUE, CANBFIRE, CANBACID, CANBBOLT, CANBICE, CANBGAS, ISGREED, CANSUMMON},
		"ancient red dragon", 5,
		0,
		{10,	63580,	29,	0,	HPT("0d8+128"),

		"2d8/3d6/2d10/3d8/3d10/1d6"}},
{"demon prince (Orcus)", 
		100, TRUE, FALSE, 'O', "19-20",
		{ISMEAN, ISUNIQUE, BMAGICHIT, CANPOISON, CANFRIGHTEN, CANSEE, CANBBOLT, CANSUMMON},
		"vampire", 4, 
		0,
		{13,	63900,	27,	-6,	HPT("0d8+120"),
		"1d10+3/2d4"}},
{"arch devil (Asmodeus)", 
		100, TRUE, FALSE, 'A', "19-20",
		{ISMEAN, ISUNIQUE, CANSEE, ISSHADOW, CANHOLD, BMAGICHIT, CANFRIGHTEN, CANHUH, CANCHILL, CANSUMMON},
		"pit fiend", 3, 
		0,
		{10,	70965,	45,	-7,	HPT("0d8+199"),
		"1d10+4"}},
{"demon prince (Demogorgon)", 
		100, TRUE, FALSE, 'D', "19-20",
		{ISMEAN, CANHUH, BMAGICHIT, DOUBLEDRAIN, CANINFEST, CANSEE, CANFRIGHTEN, ISUNIQUE, CANSUMMON},
		"glabrezu", 3, 
		0,
		{10,	74000,	45,	-8,	HPT("0d8+200"),
		"1d6/1d6"}},
{"greater god (Beebs)",
		0, TRUE, FALSE, 'b', "19",
		{ISMEAN, CANHUG, ISUNIQUE, BMAGICHIT, CANSEE},
		0, 0,
		0,
		{10,	80000,	45,	-1,	HPT("0d8+350"),
		"4d10"}},
{"greater god (Aschenbach)",
		100, TRUE, FALSE, 'a', "19",
		{ISMEAN, ISUNIQUE, BMAGICHIT, CANSEE, CANSUMMON},
		"lesser god (Dave)", 1,
		0,
		{10,	82000,	45,	-1,	HPT("0d8+350"),
		"4d10"}},
{"lesser god (Brian)",
		0, TRUE, FALSE, 'B', "19",
		{ISMEAN, ISUNIQUE, ISREGEN, BMAGICHIT, CANSEE},
		0, 0,
		0,
		{10,	85000,	45,	-1,	HPT("0d8+380"),
		"6d10"}},
{"quartermaster", 
		0, FALSE, TRUE, 'q', "8-10",
		{CANSELL},
		0, 0,
		2,
		{12,	20,	1,	-11, 	HPT("1d8+1"),
		"1d10"}},
};
